Index: /main/trunk/greenstone2/bin/script/gti.pl
===================================================================
--- /main/trunk/greenstone2/bin/script/gti.pl	(revision 24626)
+++ /main/trunk/greenstone2/bin/script/gti.pl	(revision 24627)
@@ -33,11 +33,9 @@
 }
 
+
 use iso639;
 use strict;
 use util;
 
-
-#my $anonymous_cvs_root = ":pserver:cvs_anon\@cvs.scms.waikato.ac.nz:2402/usr/local/global-cvs/gsdl-src";
-#my $anonymous_svn_root = "http://http://svn.greenstone.org/gsdl/trunk/";
 my $gsdl_root_directory = "$ENV{'GSDLHOME'}";
 my $gti_log_file = &util::filename_cat($gsdl_root_directory, "etc", "gti.log");
@@ -45,54 +43,52 @@
 
 my $gti_translation_files =
-    [ # Greenstone macrofiles
-      { 'key' => "coredm",
+[ # Greenstone macrofiles
+{ 'key' => "coredm",
 	'file_type' => "macrofile",
 	'source_file' => "macros/english.dm",
 	'target_file' => "macros/{bn:bengali;fa:farsi;gd:gaelic;id:indo;lv:latvian;pt-br:port-br;pt-pt:port-pt;zh-tr:chinese-trad;iso_639_1_target_language_name}.dm" },
-      { 'key' => "auxdm",
+
+{ 'key' => "auxdm",
 	'file_type' => "macrofile",
 	'source_file' => "macros/english2.dm",
 	'target_file' => "macros/{bn:bengali;fa:farsi;gd:gaelic;id:indo;lv:latvian;pt-br:port-br;pt-pt:port-pt;zh-tr:chinese-trad;iso_639_1_target_language_name}2.dm" },
 
-      # GLI dictionary
-      { 'key' => "glidict",
+# GLI dictionary
+{ 'key' => "glidict",
 	'file_type' => "resource_bundle",
 	'source_file' => "gli/classes/dictionary.properties",
 	'target_file' => "gli/classes/dictionary_{target_language_code}.properties" },
 
-      # GLI help
-      { 'key' => "glihelp",
+# GLI help
+{ 'key' => "glihelp",
 	'file_type' => "greenstone_xml",
 	'source_file' => "gli/help/en/help.xml",
 	'target_file' => "gli/help/{target_language_code}/help.xml" },
 
-      # Greenstone Perl modules
-      { 'key' => "perlmodules",
+# Greenstone Perl modules
+{ 'key' => "perlmodules",
 	'file_type' => "resource_bundle",
 	'source_file' => "perllib/strings.properties",
 	'target_file' => "perllib/strings_{target_language_code}.properties" },
 
-      # Greenstone tutorial exercises
-      # { 'key' => "tutorials",
-	# 'file_type' => "greenstone_xml",
-	# 'source_file' => "gsdl-documentation/tutorials/xml-source/tutorial_en.xml",
-	# 'target_file' => "gsdl-documentation/tutorials/xml-source/tutorial_{target_language_code}.xml" },
-
-      # new Greenstone.org
-      { 'key' => "greenorg",
-        'file_type' => "resource_bundle",
-        'source_file' => "greenstoneorg/website/classes/Gsc.properties",
-        'target_file' => "greenstoneorg/website/classes/Gsc_{iso_639_1_target_language_name}.properties" 
-	# 'file_type' => "macrofile",
-	# 'source_file' => "greenorg/macros/english.dm",
-	# 'target_file' => "greenorg/macros/{iso_639_1_target_language_name}.dm" 
-      }
-
-      # { 'key' => "gs3interface",
-	#'file_type' => "resource_bundle",
-	#'source_file' => "greenstone3",
-	#'target_file' => "greenstone3"
-      #}
-    ];
+# Greenstone tutorial exercises
+# { 'key' => "tutorials",
+# 'file_type' => "greenstone_xml",
+# 'source_file' => "gsdl-documentation/tutorials/xml-source/tutorial_en.xml",
+# 'target_file' => "gsdl-documentation/tutorials/xml-source/tutorial_{target_language_code}.xml" },
+
+# new Greenstone.org
+{ 'key' => "greenorg",
+	'file_type' => "resource_bundle",
+	'source_file' => "greenstoneorg/website/classes/Gsc.properties",
+	'target_file' => "greenstoneorg/website/classes/Gsc_{target_language_code}.properties" 
+}
+
+# { 'key' => "gs3interface",
+#'file_type' => "resource_bundle",
+#'source_file' => "greenstone3",
+#'target_file' => "greenstone3"
+#}
+];
 
 my @gs3_interface_files = ("AbstractBrowse", "AbstractGS2FieldSearch", "Authentication", "CrossCollectionSearch", "GATEServices", "GS2Construct", "GS2LuceneSearch", "interface_default", "interface_nzdl", "IViaSearch", "LuceneSearch", "MapRetrieve", "MapSearch", "metadata_names", "PhindPhraseBrowse", "QBRWebServicesHelp", "Visualizer");
@@ -105,52 +101,52 @@
     my @gti_command_arguments = @_;
     my $module = $_[1];
-
+	
     # Open the GTI log file for appending, or write to STDERR if that fails
     if (!open(GTI_LOG, ">>$gti_log_file")) {
-	open(GTI_LOG, ">&STDERR");
-    }
-
+		open(GTI_LOG, ">&STDERR");
+    }
+	
     # Log the command that launched this script
     &log_message("Command: $0 @ARGV");
-
+	
     # Check that a command was supplied
     if (!$gti_command) {
-	&throw_fatal_error("Missing command.");
+		&throw_fatal_error("Missing command.");
     }      
-
+	
     # Process the command
     if ($gti_command =~ /^get-all-chunks$/i) {
-	# Check that GS3 interface is the target
-	if ($module eq "gs3interface") {	   
-	    print &get_all_chunks_for_gs3(@gti_command_arguments);
-	} else {
-	    print &get_all_chunks(@gti_command_arguments);
-	}
-    }
-    if ($gti_command =~ /^get-first-n-chunks-requiring-work$/i) {
-	if ($module eq "gs3interface") {	   
-	    print &get_first_n_chunks_requiring_work_for_gs3(@gti_command_arguments);
-	} else {
-	    print &get_first_n_chunks_requiring_work(@gti_command_arguments);
-	}
-    }
-    if ($gti_command =~ /^get-language-status$/i) {
-	print &get_language_status(@gti_command_arguments);       
-    }
-    if ($gti_command =~ /^search-chunks$/i) {
-	print &search_chunks(@gti_command_arguments);
-    }
-    if ($gti_command =~ /^submit-translations$/i) {
-	# This command cannot produce any output since it reads input
-	&submit_translations(@gti_command_arguments);
-    }
-    if ($gti_command =~ /^create-glihelp-zip-file$/i) {
-	# This command cannot produce any output since it reads input
-	&create_glihelp_zip_file(@gti_command_arguments);
-    }
-#    else {
-	# The command was not recognized
-	#&throw_fatal_error("Unknown command \"$gti_command\".");
-    #}
+		# Check that GS3 interface is the target
+		if ($module eq "gs3interface") {	   
+			print &get_all_chunks_for_gs3(@gti_command_arguments);
+		} else {
+			print &get_all_chunks(@gti_command_arguments);
+		}
+    }
+    elsif ($gti_command =~ /^get-first-n-chunks-requiring-work$/i) {
+		if ($module eq "gs3interface") {	   
+			print &get_first_n_chunks_requiring_work_for_gs3(@gti_command_arguments);
+		} else {
+			print &get_first_n_chunks_requiring_work(@gti_command_arguments);
+		}
+    }
+    elsif ($gti_command =~ /^get-language-status$/i) {
+		print &get_language_status(@gti_command_arguments);       
+    }
+    elsif ($gti_command =~ /^search-chunks$/i) {
+		print &search_chunks(@gti_command_arguments);
+    }
+    elsif ($gti_command =~ /^submit-translations$/i) {
+		# This command cannot produce any output since it reads input
+		&submit_translations(@gti_command_arguments);
+    }
+    elsif ($gti_command =~ /^create-glihelp-zip-file$/i) {
+		# This command cannot produce any output since it reads input
+		&create_glihelp_zip_file(@gti_command_arguments);
+    }
+    else {
+		# The command was not recognized
+		&throw_fatal_error("Unknown command \"$gti_command\".");
+    }
 }
 
@@ -159,5 +155,5 @@
 {
     my $error_message = shift(@_);
-
+	
     # Write an XML error response
     print "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n";
@@ -165,5 +161,5 @@
     print "  <GTIError time=\"" . time() . "\">" . $error_message . "</GTIError>\n";
     print "</GTIResponse>\n";
-
+	
     # Log the error message, then die
     &log_message("Error: $error_message");
@@ -185,14 +181,14 @@
     # The key of the file to translate (ensure it is lowercase)
     my $translation_file_key = lc(shift(@_));
-
+	
     # Check that the necessary arguments were supplied
     if (!$target_language_code || !$translation_file_key) {
-	&throw_fatal_error("Missing command argument.");
-    }
-
+		&throw_fatal_error("Missing command argument.");
+    }
+	
     # Get (and check) the translation configuration
     my ($source_file, $target_file, $translation_file_type)
 	= &get_translation_configuration($target_language_code, $translation_file_key);
-
+	
     # Parse the source language and target language files
     my $source_file_path = &util::filename_cat($gsdl_root_directory, $source_file);
@@ -203,21 +199,21 @@
     my @target_file_lines = &read_file_lines($target_file_path);
     my %target_file_key_to_line_mapping = &build_key_to_line_mapping(\@target_file_lines, $translation_file_type);
-
+	
     # Filter out any automatically translated chunks
     foreach my $chunk_key (keys(%source_file_key_to_line_mapping)) {
-	if (&is_chunk_automatically_translated($chunk_key, $translation_file_type)) {
-	    delete $source_file_key_to_line_mapping{$chunk_key};
-	    delete $target_file_key_to_line_mapping{$chunk_key};
-	}
-    }
-
+		if (&is_chunk_automatically_translated($chunk_key, $translation_file_type)) {
+			delete $source_file_key_to_line_mapping{$chunk_key};
+			delete $target_file_key_to_line_mapping{$chunk_key};
+		}
+    }
+	
     my %source_file_key_to_text_mapping = &build_key_to_text_mapping(\@source_file_lines, \%source_file_key_to_line_mapping, $translation_file_type);
     my %target_file_key_to_text_mapping = &build_key_to_text_mapping(\@target_file_lines, \%target_file_key_to_line_mapping, $translation_file_type);
     &log_message("Number of source chunks: " . scalar(keys(%source_file_key_to_text_mapping)));
     &log_message("Number of target chunks: " . scalar(keys(%target_file_key_to_text_mapping)));
-
+	
     my %source_file_key_to_last_update_date_mapping = &build_key_to_last_update_date_mapping($source_file, \@source_file_lines, \%source_file_key_to_line_mapping, $translation_file_type);
     my %target_file_key_to_last_update_date_mapping = &build_key_to_last_update_date_mapping($target_file, \@target_file_lines, \%target_file_key_to_line_mapping, $translation_file_type);
-
+	
     my $xml_response = &create_xml_response_for_all_chunks($translation_file_key, $target_file, \%source_file_key_to_text_mapping, \%target_file_key_to_text_mapping, \%source_file_key_to_last_update_date_mapping, \%target_file_key_to_last_update_date_mapping);   
     
@@ -234,14 +230,14 @@
     # The number of chunks to return (defaults to one if not specified)
     my $num_chunks_to_return = shift(@_) || "1";
-
+	
     # Check that the necessary arguments were supplied
     if (!$target_language_code || !$translation_file_key) {
-	&throw_fatal_error("Missing command argument.");
-    }
-
+		&throw_fatal_error("Missing command argument.");
+    }
+	
     # Get (and check) the translation configuration
     my ($source_file, $target_file, $translation_file_type)
 	= &get_translation_configuration($target_language_code, $translation_file_key);
-
+	
     # Parse the source language and target language files
     my $source_file_path = &util::filename_cat($gsdl_root_directory, $source_file);
@@ -252,22 +248,22 @@
     my @target_file_lines = &read_file_lines($target_file_path);
     my %target_file_key_to_line_mapping = &build_key_to_line_mapping(\@target_file_lines, $translation_file_type);
-
+	
     # Filter out any automatically translated chunks
     foreach my $chunk_key (keys(%source_file_key_to_line_mapping)) {
-	if (&is_chunk_automatically_translated($chunk_key, $translation_file_type)) {
-	    delete $source_file_key_to_line_mapping{$chunk_key};
-	    delete $target_file_key_to_line_mapping{$chunk_key};
-	}
-    }
-
+		if (&is_chunk_automatically_translated($chunk_key, $translation_file_type)) {
+			delete $source_file_key_to_line_mapping{$chunk_key};
+			delete $target_file_key_to_line_mapping{$chunk_key};
+		}
+    }
+	
     my %source_file_key_to_text_mapping = &build_key_to_text_mapping(\@source_file_lines, \%source_file_key_to_line_mapping, $translation_file_type);
     my %target_file_key_to_text_mapping = &build_key_to_text_mapping(\@target_file_lines, \%target_file_key_to_line_mapping, $translation_file_type);
     &log_message("Number of source chunks: " . scalar(keys(%source_file_key_to_text_mapping)));
     &log_message("Number of target chunks: " . scalar(keys(%target_file_key_to_text_mapping)));
-
+	
     # Determine the target file chunks requiring translation
     my @target_file_keys_requiring_translation = &determine_chunks_requiring_translation(\%source_file_key_to_text_mapping, \%target_file_key_to_text_mapping);
     &log_message("Number of target chunks requiring translation: " . scalar(@target_file_keys_requiring_translation));
-
+	
     # Determine the target file chunks requiring updating
     my %source_file_key_to_last_update_date_mapping = &build_key_to_last_update_date_mapping($source_file, \@source_file_lines, \%source_file_key_to_line_mapping, $translation_file_type);
@@ -275,5 +271,5 @@
     my @target_file_keys_requiring_updating = &determine_chunks_requiring_updating(\%source_file_key_to_last_update_date_mapping, \%target_file_key_to_last_update_date_mapping);
     &log_message("Number of target chunks requiring updating: " . scalar(@target_file_keys_requiring_updating));
-
+	
     my $xml_response = &create_xml_response_for_chunks_requiring_work($translation_file_key, $target_file, scalar(keys(%source_file_key_to_text_mapping)), \@target_file_keys_requiring_translation, \@target_file_keys_requiring_updating, $num_chunks_to_return, \%source_file_key_to_text_mapping, \%target_file_key_to_text_mapping, \%source_file_key_to_last_update_date_mapping, \%target_file_key_to_last_update_date_mapping);   
     
@@ -286,80 +282,80 @@
     # The code of the target language (ensure it is lowercase)
     my $target_language_code = lc(shift(@_));
-
+	
     # Check that the necessary arguments were supplied
     if (!$target_language_code) {
-	&throw_fatal_error("Missing command argument.");
-    }
-
+		&throw_fatal_error("Missing command argument.");
+    }
+	
     # Form an XML response to the command
     my $xml_response = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n";
     $xml_response .= "<GTIResponse>\n";
     $xml_response .= "  <LanguageStatus code=\"$target_language_code\">\n";
-
+	
     foreach my $translation_file (@$gti_translation_files) {	
-	my ($num_source_chunks, $num_target_chunks, $num_chunks_requiring_translation, $num_chunks_requiring_updating) = 0;
-	my $target_file_name = "";
-	
-	if ($translation_file->{'key'} eq "gs3interface") {
-	    my (%source_file_key_to_text_mapping, %target_file_key_to_text_mapping, %source_file_key_to_last_update_date_mapping, %target_file_key_to_last_update_date_mapping ) = ();
-	    &build_gs3_configuration($target_language_code, \%source_file_key_to_text_mapping, \%target_file_key_to_text_mapping, \%source_file_key_to_last_update_date_mapping, \%target_file_key_to_last_update_date_mapping );    
-	    
-	    my @target_file_keys_requiring_translation = &determine_chunks_requiring_translation(\%source_file_key_to_text_mapping, \%target_file_key_to_text_mapping);	    
-	    my @target_file_keys_requiring_updating = &determine_chunks_requiring_updating(\%source_file_key_to_last_update_date_mapping, \%target_file_key_to_last_update_date_mapping);
-
-	    $num_source_chunks = scalar(keys(%source_file_key_to_text_mapping));
-	    $num_target_chunks = scalar(keys(%target_file_key_to_text_mapping));
-	    $num_chunks_requiring_translation = scalar(@target_file_keys_requiring_translation);
-	    $num_chunks_requiring_updating = scalar(@target_file_keys_requiring_updating);
-	}
-	else {
-	    # Get (and check) the translation configuration
-	    my ($source_file, $target_file, $translation_file_type) = &get_translation_configuration($target_language_code, $translation_file->{'key'});
-	    $target_file_name = $target_file;
-
-	    # Parse the source language and target language files
-	    my $source_file_path = &util::filename_cat($gsdl_root_directory, $source_file);
-	    my @source_file_lines = &read_file_lines($source_file_path);
-	    my %source_file_key_to_line_mapping = &build_key_to_line_mapping(\@source_file_lines, $translation_file_type);
-
-	    my $target_file_path = &util::filename_cat($gsdl_root_directory, $target_file);
-	    my @target_file_lines = &read_file_lines($target_file_path);
-	    my %target_file_key_to_line_mapping = &build_key_to_line_mapping(\@target_file_lines, $translation_file_type);
-
-	    # Filter out any automatically translated chunks
-	    foreach my $chunk_key (keys(%source_file_key_to_line_mapping)) {
-		if (&is_chunk_automatically_translated($chunk_key, $translation_file_type)) {
-		    delete $source_file_key_to_line_mapping{$chunk_key};
-		    delete $target_file_key_to_line_mapping{$chunk_key};
-		}
-	    }
-
-	    my %source_file_key_to_text_mapping = &build_key_to_text_mapping(\@source_file_lines, \%source_file_key_to_line_mapping, $translation_file_type);
-	    my %target_file_key_to_text_mapping = &build_key_to_text_mapping(\@target_file_lines, \%target_file_key_to_line_mapping, $translation_file_type);
-
-	    # Determine the target file chunks requiring translation
-	    my @target_file_keys_requiring_translation = &determine_chunks_requiring_translation(\%source_file_key_to_text_mapping, \%target_file_key_to_text_mapping);	    
-
-	    # Determine the target file chunks requiring updating
-	    my @target_file_keys_requiring_updating = ();
-	    if (-e $target_file_path) {
-		my %source_file_key_to_last_update_date_mapping = &build_key_to_last_update_date_mapping($source_file, \@source_file_lines, \%source_file_key_to_line_mapping, $translation_file_type);
-		my %target_file_key_to_last_update_date_mapping = &build_key_to_last_update_date_mapping($target_file, \@target_file_lines, \%target_file_key_to_line_mapping, $translation_file_type);
-		@target_file_keys_requiring_updating = &determine_chunks_requiring_updating(\%source_file_key_to_last_update_date_mapping, \%target_file_key_to_last_update_date_mapping);		
-	    }
-
-	    $num_source_chunks = scalar(keys(%source_file_key_to_text_mapping));
-	    $num_target_chunks = scalar(keys(%target_file_key_to_text_mapping));
-	    $num_chunks_requiring_translation = scalar(@target_file_keys_requiring_translation);
-	    $num_chunks_requiring_updating = scalar(@target_file_keys_requiring_updating);
-	}
-	
-	&log_message("Status of " . $translation_file->{'key'});
-	&log_message("Number of source chunks: " . $num_source_chunks);
-	&log_message("Number of target chunks: " . $num_target_chunks);
-	&log_message("Number of target chunks requiring translation: " . $num_chunks_requiring_translation);
-	&log_message("Number of target chunks requiring updating: " . $num_chunks_requiring_updating);
-
-	$xml_response .= "    <TranslationFile"
+		my ($num_source_chunks, $num_target_chunks, $num_chunks_requiring_translation, $num_chunks_requiring_updating) = 0;
+		my $target_file_name = "";
+		
+		if ($translation_file->{'key'} eq "gs3interface") {
+			my (%source_file_key_to_text_mapping, %target_file_key_to_text_mapping, %source_file_key_to_last_update_date_mapping, %target_file_key_to_last_update_date_mapping ) = ();
+			&build_gs3_configuration($target_language_code, \%source_file_key_to_text_mapping, \%target_file_key_to_text_mapping, \%source_file_key_to_last_update_date_mapping, \%target_file_key_to_last_update_date_mapping );    
+			
+			my @target_file_keys_requiring_translation = &determine_chunks_requiring_translation(\%source_file_key_to_text_mapping, \%target_file_key_to_text_mapping);	    
+			my @target_file_keys_requiring_updating = &determine_chunks_requiring_updating(\%source_file_key_to_last_update_date_mapping, \%target_file_key_to_last_update_date_mapping);
+			
+			$num_source_chunks = scalar(keys(%source_file_key_to_text_mapping));
+			$num_target_chunks = scalar(keys(%target_file_key_to_text_mapping));
+			$num_chunks_requiring_translation = scalar(@target_file_keys_requiring_translation);
+			$num_chunks_requiring_updating = scalar(@target_file_keys_requiring_updating);
+		}
+		else {
+			# Get (and check) the translation configuration
+			my ($source_file, $target_file, $translation_file_type) = &get_translation_configuration($target_language_code, $translation_file->{'key'});
+			$target_file_name = $target_file;
+			
+			# Parse the source language and target language files
+			my $source_file_path = &util::filename_cat($gsdl_root_directory, $source_file);
+			my @source_file_lines = &read_file_lines($source_file_path);
+			my %source_file_key_to_line_mapping = &build_key_to_line_mapping(\@source_file_lines, $translation_file_type);
+			
+			my $target_file_path = &util::filename_cat($gsdl_root_directory, $target_file);
+			my @target_file_lines = &read_file_lines($target_file_path);
+			my %target_file_key_to_line_mapping = &build_key_to_line_mapping(\@target_file_lines, $translation_file_type);
+			
+			# Filter out any automatically translated chunks
+			foreach my $chunk_key (keys(%source_file_key_to_line_mapping)) {
+				if (&is_chunk_automatically_translated($chunk_key, $translation_file_type)) {
+					delete $source_file_key_to_line_mapping{$chunk_key};
+					delete $target_file_key_to_line_mapping{$chunk_key};
+				}
+			}
+			
+			my %source_file_key_to_text_mapping = &build_key_to_text_mapping(\@source_file_lines, \%source_file_key_to_line_mapping, $translation_file_type);
+			my %target_file_key_to_text_mapping = &build_key_to_text_mapping(\@target_file_lines, \%target_file_key_to_line_mapping, $translation_file_type);
+			
+			# Determine the target file chunks requiring translation
+			my @target_file_keys_requiring_translation = &determine_chunks_requiring_translation(\%source_file_key_to_text_mapping, \%target_file_key_to_text_mapping);	    
+			
+			# Determine the target file chunks requiring updating
+			my @target_file_keys_requiring_updating = ();
+			if (-e $target_file_path) {
+				my %source_file_key_to_last_update_date_mapping = &build_key_to_last_update_date_mapping($source_file, \@source_file_lines, \%source_file_key_to_line_mapping, $translation_file_type);
+				my %target_file_key_to_last_update_date_mapping = &build_key_to_last_update_date_mapping($target_file, \@target_file_lines, \%target_file_key_to_line_mapping, $translation_file_type);
+				@target_file_keys_requiring_updating = &determine_chunks_requiring_updating(\%source_file_key_to_last_update_date_mapping, \%target_file_key_to_last_update_date_mapping);		
+			}
+			
+			$num_source_chunks = scalar(keys(%source_file_key_to_text_mapping));
+			$num_target_chunks = scalar(keys(%target_file_key_to_text_mapping));
+			$num_chunks_requiring_translation = scalar(@target_file_keys_requiring_translation);
+			$num_chunks_requiring_updating = scalar(@target_file_keys_requiring_updating);
+		}
+		
+		&log_message("Status of " . $translation_file->{'key'});
+		&log_message("Number of source chunks: " . $num_source_chunks);
+		&log_message("Number of target chunks: " . $num_target_chunks);
+		&log_message("Number of target chunks requiring translation: " . $num_chunks_requiring_translation);
+		&log_message("Number of target chunks requiring updating: " . $num_chunks_requiring_updating);
+		
+		$xml_response .= "    <TranslationFile"
 	    . " key=\"" . $translation_file->{'key'} . "\""
 	    . " target_file_path=\"" . $target_file_name . "\""
@@ -368,7 +364,7 @@
 	    . " num_chunks_requiring_updating=\"" . $num_chunks_requiring_updating . "\"\/>\n";
     }
-
+	
     $xml_response .= "  </LanguageStatus>\n";
-
+	
     $xml_response .= "</GTIResponse>\n";
     return $xml_response;
@@ -384,10 +380,10 @@
     # The query string
     my $query_string = join(' ', @_);
-
+	
     # Check that the necessary arguments were supplied
     if (!$target_language_code || !$translation_file_key || !$query_string) {
-	&throw_fatal_error("Missing command argument.");
-    }
-
+		&throw_fatal_error("Missing command argument.");
+    }
+	
     my ($source_file, $target_file, $translation_file_type) = ();
     my %source_file_key_to_text_mapping = ();
@@ -396,61 +392,61 @@
     
     if ($translation_file_key ne "gs3interface") {
-	# Get (and check) the translation configuration
-	($source_file, $target_file, $translation_file_type) = &get_translation_configuration($target_language_code, $translation_file_key);
-
-	# Parse the source language and target language files
-	my $source_file_path = &util::filename_cat($gsdl_root_directory, $source_file);
-	my @source_file_lines = &read_file_lines($source_file_path);
-	my %source_file_key_to_line_mapping = &build_key_to_line_mapping(\@source_file_lines, $translation_file_type);
-
-	my $target_file_path = &util::filename_cat($gsdl_root_directory, $target_file);
-	my @target_file_lines = &read_file_lines($target_file_path);
-	my %target_file_key_to_line_mapping = &build_key_to_line_mapping(\@target_file_lines, $translation_file_type);
-
-	# Filter out any automatically translated chunks
-	foreach my $chunk_key (keys(%source_file_key_to_line_mapping)) {
-	    if (&is_chunk_automatically_translated($chunk_key, $translation_file_type)) {
-		delete $source_file_key_to_line_mapping{$chunk_key};
-		delete $target_file_key_to_line_mapping{$chunk_key};
-	    }
-	}
-
-	%source_file_key_to_text_mapping = &build_key_to_text_mapping(\@source_file_lines, \%source_file_key_to_line_mapping, $translation_file_type);
-	%target_file_key_to_text_mapping = &build_key_to_text_mapping(\@target_file_lines, \%target_file_key_to_line_mapping, $translation_file_type);
+		# Get (and check) the translation configuration
+		($source_file, $target_file, $translation_file_type) = &get_translation_configuration($target_language_code, $translation_file_key);
+		
+		# Parse the source language and target language files
+		my $source_file_path = &util::filename_cat($gsdl_root_directory, $source_file);
+		my @source_file_lines = &read_file_lines($source_file_path);
+		my %source_file_key_to_line_mapping = &build_key_to_line_mapping(\@source_file_lines, $translation_file_type);
+		
+		my $target_file_path = &util::filename_cat($gsdl_root_directory, $target_file);
+		my @target_file_lines = &read_file_lines($target_file_path);
+		my %target_file_key_to_line_mapping = &build_key_to_line_mapping(\@target_file_lines, $translation_file_type);
+		
+		# Filter out any automatically translated chunks
+		foreach my $chunk_key (keys(%source_file_key_to_line_mapping)) {
+			if (&is_chunk_automatically_translated($chunk_key, $translation_file_type)) {
+				delete $source_file_key_to_line_mapping{$chunk_key};
+				delete $target_file_key_to_line_mapping{$chunk_key};
+			}
+		}
+		
+		%source_file_key_to_text_mapping = &build_key_to_text_mapping(\@source_file_lines, \%source_file_key_to_line_mapping, $translation_file_type);
+		%target_file_key_to_text_mapping = &build_key_to_text_mapping(\@target_file_lines, \%target_file_key_to_line_mapping, $translation_file_type);
     }
     else {
-	# Not needed in this case
-	my (%source_file_key_to_gti_command_mapping, %target_file_key_to_gti_command_mapping) = ();
-	&build_gs3_configuration($target_language_code, \%source_file_key_to_text_mapping, \%target_file_key_to_text_mapping,
-				 \%source_file_key_to_gti_command_mapping, \%target_file_key_to_gti_command_mapping);
-    }
-
+		# Not needed in this case
+		my (%source_file_key_to_gti_command_mapping, %target_file_key_to_gti_command_mapping) = ();
+		&build_gs3_configuration($target_language_code, \%source_file_key_to_text_mapping, \%target_file_key_to_text_mapping,
+		\%source_file_key_to_gti_command_mapping, \%target_file_key_to_gti_command_mapping);
+    }
+	
     &log_message("Number of source chunks: " . scalar(keys(%source_file_key_to_text_mapping)));
     &log_message("Number of target chunks: " . scalar(keys(%target_file_key_to_text_mapping)));
-
+	
     # Determine the target file chunks matching the query
     my @target_file_keys_matching_query = ();
     foreach my $chunk_key (keys(%target_file_key_to_text_mapping)) {
-	my $target_file_text = $target_file_key_to_text_mapping{$chunk_key};
-	if ($target_file_text =~ /$query_string/i) {
-	    # &log_message("Chunk with key $chunk_key matches query.");
-	    push(@target_file_keys_matching_query, $chunk_key);
-	}
-    }
-
+		my $target_file_text = $target_file_key_to_text_mapping{$chunk_key};
+		if ($target_file_text =~ /$query_string/i) {
+			# &log_message("Chunk with key $chunk_key matches query.");
+			push(@target_file_keys_matching_query, $chunk_key);
+		}
+    }
+	
     # Form an XML response to the command
     my $xml_response = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n";
     $xml_response .= "<GTIResponse>\n";
-
+	
     $xml_response .= "  <ChunksMatchingQuery size=\"" . scalar(@target_file_keys_matching_query) . "\">\n";
     foreach my $chunk_key (@target_file_keys_matching_query) {
- 	my $target_file_chunk_text = &make_text_xml_safe($target_file_key_to_text_mapping{$chunk_key});
-
- 	$xml_response .= "    <Chunk key=\"$chunk_key\">\n";
- 	$xml_response .= "      <TargetFileText>$target_file_chunk_text</TargetFileText>\n";
- 	$xml_response .= "    </Chunk>\n";
+		my $target_file_chunk_text = &make_text_xml_safe($target_file_key_to_text_mapping{$chunk_key});
+		
+		$xml_response .= "    <Chunk key=\"$chunk_key\">\n";
+		$xml_response .= "      <TargetFileText>$target_file_chunk_text</TargetFileText>\n";
+		$xml_response .= "    </Chunk>\n";
     }
     $xml_response .= "  </ChunksMatchingQuery>\n";
-
+	
     $xml_response .= "</GTIResponse>\n";
     return $xml_response;
@@ -468,9 +464,9 @@
     # Whether to submit a target chunk even if it hasn't changed
     my $force_submission_flag = shift(@_);
-
+	
     # Check that the necessary arguments were supplied
     if (!$target_language_code || !$translation_file_key || !$submitter_username) {
-	&log_message("Fatal error (but cannot be thrown): Missing command argument.");
-	die "\n";
+		&log_message("Fatal error (but cannot be thrown): Missing command argument.");
+		die "\n";
     }
     
